> ## Documentation Index
> Fetch the complete documentation index at: https://developers.fireblocks.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List unspent outputs (UTXOs)

> Returns a paginated list of unspent transaction outputs (UTXOs) for a UTXO-based asset in a vault account, with optional filters for labels, statuses, amounts, and more.
**Note:** These endpoints are currently in beta and might be subject to changes.
Endpoint Permission: Admin, Non-Signing Admin, Signer, Approver, Editor, Viewer.



## OpenAPI

````yaml https://docs.fireblocks.com/api/v1/swagger.yaml get /utxo_management/{vaultAccountId}/{assetId}/unspent_outputs
openapi: 3.0.0
info:
  title: Fireblocks API
  description: >
    Fireblocks provides a suite of applications to manage digital asset
    operations and a complete development platform to build your business on the
    blockchain.


    - Visit our website for more information: [Fireblocks
    Website](https://fireblocks.com)

    - Visit our developer docs: [Fireblocks
    DevPortal](https://developers.fireblocks.com)
  version: 1.6.2
  contact:
    email: developers@fireblocks.com
servers:
  - url: https://api.fireblocks.io/v1
    description: Fireblocks Production Environment Base URL
  - url: https://sandbox-api.fireblocks.io/v1
    description: Fireblocks Sandbox Environment Base URL
security: []
paths:
  /utxo_management/{vaultAccountId}/{assetId}/unspent_outputs:
    get:
      tags:
        - UTXO Management (Beta)
      summary: List unspent outputs (UTXOs)
      description: >-
        Returns a paginated list of unspent transaction outputs (UTXOs) for a
        UTXO-based asset in a vault account, with optional filters for labels,
        statuses, amounts, and more.

        **Note:** These endpoints are currently in beta and might be subject to
        changes.

        Endpoint Permission: Admin, Non-Signing Admin, Signer, Approver, Editor,
        Viewer.
      operationId: getUtxos
      parameters:
        - in: path
          name: vaultAccountId
          required: true
          description: The ID of the vault account
          schema:
            type: string
            format: numeric
            x-fb-entity: vault_account
        - in: path
          name: assetId
          required: true
          description: The ID of the asset
          schema:
            type: string
            x-fb-entity: asset
        - in: query
          name: pageCursor
          required: false
          description: Cursor for the next page of results
          schema:
            type: string
          example: MjAyNS0wNy0wOSAxMDo1MzoxMy40NTI=:NA==
        - in: query
          name: pageSize
          required: false
          description: Number of results per page (max 250, default 50)
          schema:
            type: integer
            minimum: 1
            maximum: 250
            default: 50
          example: 50
        - in: query
          name: sort
          required: false
          description: Field to sort by
          schema:
            type: string
            enum:
              - AMOUNT
              - CONFIRMATIONS
          example: AMOUNT
        - in: query
          name: order
          required: false
          description: Sort order
          schema:
            type: string
            enum:
              - ASC
              - DESC
          example: ASC
        - in: query
          name: includeAllLabels
          required: false
          description: Only return UTXOs that have ALL of these labels (AND logic).
          schema:
            type: array
            items:
              type: string
          example:
            - cold-storage
        - in: query
          name: includeAnyLabels
          required: false
          description: Return UTXOs that have ANY of these labels (OR logic).
          schema:
            type: array
            items:
              type: string
          example:
            - vip
            - high-value
        - in: query
          name: excludeAnyLabels
          required: false
          description: Exclude UTXOs that have ANY of these labels.
          schema:
            type: array
            items:
              type: string
          example:
            - deprecated
        - in: query
          name: includeStatuses
          required: false
          description: Filter by UTXO statuses to include.
          schema:
            type: array
            items:
              type: string
          example:
            - AVAILABLE
            - PENDING
        - in: query
          name: address
          required: false
          description: Filter by address
          schema:
            type: string
          example: 1A1zP1eP5QGefi2DMPTfTL5SLmv7DivfNa
        - in: query
          name: minAmount
          required: false
          description: Minimum amount filter
          schema:
            type: string
          example: '0.001'
        - in: query
          name: maxAmount
          required: false
          description: Maximum amount filter
          schema:
            type: string
          example: '1.0'
        - in: query
          name: useChange
          required: false
          description: Include change outputs
          schema:
            type: boolean
          example: true
        - in: query
          name: useCoinbase
          required: false
          description: Include coinbase outputs
          schema:
            type: boolean
          example: true
      responses:
        '200':
          description: A paginated list of UTXOs
          headers:
            X-Request-ID:
              $ref: '#/components/headers/X-Request-ID'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListUtxosResponse'
        default:
          $ref: '#/components/responses/Error'
      x-codeSamples:
        - lang: TypeScript
          source: >-
            const response: Promise<FireblocksResponse<ListUtxosResponse>> =
            fireblocks.uTXOManagementBeta.getUtxos(uTXOManagementBetaApiGetUtxosRequest);
        - lang: Java
          source: >-
            CompletableFuture<ApiResponse<ListUtxosResponse>> response =
            fireblocks.uTXOManagementBeta().getUtxos(vaultAccountId, assetId,
            pageCursor, pageSize, sort, order, includeAllLabels,
            includeAnyLabels, excludeAnyLabels, includeStatuses, address,
            minAmount, maxAmount, useChange, useCoinbase);
        - lang: Python
          source: >-
            response =
            fireblocks.u_t_x_o_management_beta.get_utxos(vault_account_id,
            asset_id, page_cursor, page_size, sort, order, include_all_labels,
            include_any_labels, exclude_any_labels, include_statuses, address,
            min_amount, max_amount, use_change, use_coinbase);
components:
  headers:
    X-Request-ID:
      schema:
        type: string
      description: >-
        Unique ID correlated to the API request. Please provide it in any
        support ticket you create or on Github issues related to Fireblocks SDKs
  schemas:
    ListUtxosResponse:
      type: object
      properties:
        data:
          type: array
          description: List of UTXOs
          items:
            $ref: '#/components/schemas/UtxoOutput'
        next:
          type: string
          description: Cursor to the next page
          example: MjAyNS0wNy0wOSAxMDo1MzoxMy40NTI=:NA==
          nullable: true
      required:
        - data
    UtxoOutput:
      type: object
      required:
        - input
        - utxoId
        - address
        - amount
        - status
      properties:
        input:
          $ref: '#/components/schemas/UtxoInput-2'
        utxoId:
          type: string
          description: The unique UTXO identifier
          example: '123456'
        address:
          type: string
          description: The address holding this UTXO
          example: 1A1zP1eP5QGefi2DMPTfTL5SLmv7DivfNa
        amount:
          type: string
          description: The UTXO amount in the asset's native unit
          example: '0.00150000'
        confirmations:
          type: integer
          description: Number of confirmations
          example: 6
        status:
          type: string
          description: The UTXO status
          example: AVAILABLE
          enum:
            - PENDING
            - AVAILABLE
            - FROZEN
            - SELECTED
        isChange:
          type: boolean
          description: Whether this is a change output
          example: false
        isCoinbase:
          type: boolean
          description: Whether this is a coinbase output
          example: false
        fbTxId:
          type: string
          description: The Fireblocks transaction ID that created this UTXO
          example: b70701f4-d7b1-4795-a8ee-b09cdb5b850e
        createdByHash:
          type: string
          description: The on-chain block hash where this UTXO was created
          example: 000000000000000000024bead8df69990852c202db0e0097c1a12ea637d7e96d
        spentByFbTxId:
          type: array
          description: Fireblocks transaction IDs that selected/spent this UTXO
          example:
            - b70701f4-d7b1-4795-a8ee-b09cdb5b850e
          items:
            type: string
        createdByHeight:
          type: integer
          description: The block height at which this UTXO was created
          example: 800100
        createdAt:
          type: string
          format: date-time
          description: The timestamp when this UTXO was created
          example: '2025-01-16T15:45:00Z'
        updatedAt:
          type: string
          format: date-time
          description: The timestamp when this UTXO was last updated
          example: '2025-01-16T15:45:00Z'
        labels:
          type: array
          description: Labels attached to this UTXO
          example:
            - cold-storage
            - vip
          items:
            type: string
    ErrorSchema:
      type: object
      properties:
        message:
          type: string
        code:
          type: number
    UtxoInput-2:
      type: object
      properties:
        txHash:
          type: string
          description: The transaction hash
          example: b34f0c3ce612f1e5a5c19d6b1e6b5e3e7f1a2b3c4d5e6f7a8b9c0d1e2f3a4b5c
        index:
          type: integer
          description: The output index (vout)
          example: 0
  responses:
    Error:
      description: Error Response
      headers:
        X-Request-ID:
          $ref: '#/components/headers/X-Request-ID'
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorSchema'

````